package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.PacoteConvenioDAO;
import com.rjconsultores.ventaboletos.entidad.PacoteConvenio;
import com.rjconsultores.ventaboletos.service.PacoteConvenioService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("pacoteConvenioService")
public class PacoteConvenioServiceImpl implements PacoteConvenioService {

    @Autowired
    private PacoteConvenioDAO pacoteConvenioDAO;

    public List<PacoteConvenio> obtenerTodos() {
        return pacoteConvenioDAO.obtenerTodos();
    }

    public PacoteConvenio obtenerID(Long id) {
        return pacoteConvenioDAO.obtenerID(id);
    }

    @Transactional
    public PacoteConvenio suscribir(PacoteConvenio entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return pacoteConvenioDAO.suscribir(entidad);
    }

    @Transactional
    public PacoteConvenio actualizacion(PacoteConvenio entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return pacoteConvenioDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(PacoteConvenio entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        pacoteConvenioDAO.actualizacion(entidad);
    }

    public List<PacoteConvenio> buscar(String deschotel) {
        return pacoteConvenioDAO.buscar(deschotel);
    }
}
